import { StateContext, Store } from '@ngxs/store';
import { Node, Entity, NodeEntity } from './file-browser.model';
import { GenerateFileBrowser, GetNode, GenerateTreeLevels, GenerateHistory, ToggleFolder } from './file-browser.actions';
import { ListSortingService } from '../services/list-sorting.service';
export interface FileBrowserStateModel {
    nodes: Node[];
    currentNode: Node;
    childNodes: Node[];
    entities: Entity[];
    currentEntity: Entity;
    childEntities: Entity[];
    nodeEntity: NodeEntity[];
    history: Entity[];
    nodeSelected: Node;
}
export declare class FileBrowserState {
    private store;
    private listSorting;
    constructor(store: Store, listSorting: ListSortingService);
    static getNodes(state: FileBrowserStateModel): NodeEntity[];
    static getChildEntities(state: FileBrowserStateModel): Entity[];
    static getHistory(state: FileBrowserStateModel): Entity[];
    static getNodeSelected(state: FileBrowserStateModel): Node;
    generateFileBrowser({patchState}: StateContext<FileBrowserStateModel>, {nodes, entities, root}: GenerateFileBrowser): void;
    getNode({getState, patchState}: StateContext<FileBrowserStateModel>, {node}: GetNode): void;
    generateHistory({getState, patchState}: StateContext<FileBrowserStateModel>, {node}: GenerateHistory): void;
    generateTreeFirstLevel({getState, patchState}: StateContext<FileBrowserStateModel>): void;
    generateTreeLevels({getState, patchState}: StateContext<FileBrowserStateModel>, {level}: GenerateTreeLevels): void;
    toggleFolder({getState, patchState}: StateContext<FileBrowserStateModel>, {node}: ToggleFolder): void;
}
